import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { GoodsSpecRel, GoodsSpecRelParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商品规格值
 */
export async function pageGoodsSpecRel(params: GoodsSpecRelParam) {
  const res = await request.get<ApiResult<PageResult<GoodsSpecRel>>>(
    MODULES_API_URL + '/shop/goods-spec-rel/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品规格值列表
 */
export async function listGoodsSpecRel(params?: GoodsSpecRelParam) {
  const res = await request.get<ApiResult<GoodsSpecRel[]>>(
    MODULES_API_URL + '/shop/goods-spec-rel',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品规格值
 */
export async function addGoodsSpecRel(data: GoodsSpecRel) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-spec-rel',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品规格值
 */
export async function updateGoodsSpecRel(data: GoodsSpecRel) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-spec-rel',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品规格值
 */
export async function removeGoodsSpecRel(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-spec-rel/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品规格值
 */
export async function removeBatchGoodsSpecRel(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-spec-rel/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品规格值
 */
export async function getGoodsSpecRel(id: number) {
  const res = await request.get<ApiResult<GoodsSpecRel>>(
    MODULES_API_URL + '/shop/goods-spec-rel/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
